"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.badgeBgs = exports.Badge = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactBootstrap = require("react-bootstrap");

var _excluded = ["children", "badge", "className"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var badgeBgs = {
  PRIMARY: 'primary',
  SECONDARY: 'secondary',
  SUCCESS: 'success',
  DANGER: 'danger',
  WARNING: 'warning',
  INFO: 'info',
  DARK: 'dark',
  LIGHT: 'light'
};
exports.badgeBgs = badgeBgs;

var Badge = function Badge(_ref) {
  var children = _ref.children,
      badge = _ref.badge,
      className = _ref.className,
      props = _objectWithoutProperties(_ref, _excluded);

  if (badge) {
    return /*#__PURE__*/_react.default.createElement("div", {
      className: "position-relative"
    }, /*#__PURE__*/_react.default.createElement(_reactBootstrap.Badge, _extends({
      className: "position-absolute top-0 start-100 translate-middle badge rounded-pill ".concat(className)
    }, props), badge, /*#__PURE__*/_react.default.createElement("span", {
      className: "visually-hidden"
    })), children);
  }

  return /*#__PURE__*/_react.default.createElement(_reactBootstrap.Badge, _extends({
    className: className
  }, props), children);
};

exports.Badge = Badge;
Badge.defaultProps = {
  className: '',
  bg: badgeBgs.SECONDARY,
  pill: false,
  text: undefined,
  badge: undefined
};
Badge.propTypes = {
  className: _propTypes.default.string,
  bg: _propTypes.default.oneOf(Object.values(badgeBgs)),
  pill: _propTypes.default.bool,
  text: _propTypes.default.oneOf(Object.values(badgeBgs)),
  badge: _propTypes.default.any
};
var _default = Badge;
exports.default = _default;