"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buttonSize = exports.buttonVariant = exports.Button = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactBootstrap = require("react-bootstrap");

require("./index.css");

var _excluded = ["loading", "loadingText", "children", "SpinnerProps"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var buttonVariant = {
  PRIMARY: 'primary',
  SECONDARY: 'secondary',
  SUCCESS: 'success',
  DANGER: 'danger',
  WARNING: 'warning',
  INFO: 'info',
  DARK: 'dark',
  LIGHT: 'light',
  LINK: 'link',
  OUTLINE_PRIMARY: 'outline-primary',
  OUTLINE_SECONDARY: 'outline-secondary',
  OUTLINE_SUCCESS: 'outline-success',
  OUTLINE_DANGER: 'outline-danger',
  OUTLINE_WARNING: 'outline-warning',
  OUTLINE_INFO: 'outline-info',
  OUTLINE_DARK: 'outline-dark',
  OUTLINE_LIGHT: 'outline-light'
};
exports.buttonVariant = buttonVariant;
var buttonSize = {
  SM: 'sm',
  LG: 'lg'
};
exports.buttonSize = buttonSize;

var Button = function Button(_ref) {
  var loading = _ref.loading,
      loadingText = _ref.loadingText,
      children = _ref.children,
      SpinnerProps = _ref.SpinnerProps,
      props = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/_react.default.createElement(_reactBootstrap.Button, props, loading ? /*#__PURE__*/_react.default.createElement("span", {
    className: "btn-loading-container"
  }, /*#__PURE__*/_react.default.createElement(_reactBootstrap.Spinner, SpinnerProps), /*#__PURE__*/_react.default.createElement("span", {
    className: "btn-loading-text"
  }, loadingText)) : children);
};

exports.Button = Button;
Button.defaultProps = {
  children: '',
  variant: 'secondary',
  size: 'sm',
  active: false,
  disabled: false,
  onClick: undefined,
  loading: false,
  loadingText: 'Loading',
  SpinnerProps: {
    size: 'sm',
    animation: 'border'
  }
};
Button.propTypes = {
  children: _propTypes.default.any,
  variant: _propTypes.default.oneOf(Object.values(buttonVariant)),
  size: _propTypes.default.oneOf(Object.values(buttonSize)),
  active: _propTypes.default.bool,
  disabled: _propTypes.default.bool,
  onClick: _propTypes.default.func,
  loading: _propTypes.default.bool,
  loadingText: _propTypes.default.string,
  SpinnerProps: _propTypes.default.instanceOf(Object)
};
var _default = Button;
exports.default = _default;