"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.cardTexts = exports.cardBgs = exports.Card = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactBootstrap = require("react-bootstrap");

var _excluded = ["width", "header", "title", "body"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Header = _reactBootstrap.Card.Header,
    Body = _reactBootstrap.Card.Body,
    Title = _reactBootstrap.Card.Title,
    Text = _reactBootstrap.Card.Text;
var cardBgs = {
  PRIMARY: 'primary',
  SECONDARY: 'secondary',
  SUCCESS: 'success',
  DANGER: 'danger',
  WARNING: 'warning',
  INFO: 'info',
  DARK: 'dark',
  LIGHT: 'light'
};
exports.cardBgs = cardBgs;

var cardTexts = _objectSpread(_objectSpread({}, cardBgs), {}, {
  WHITE: 'white',
  MUTED: 'muted'
});

exports.cardTexts = cardTexts;

var Card = function Card(_ref) {
  var width = _ref.width,
      header = _ref.header,
      title = _ref.title,
      body = _ref.body,
      props = _objectWithoutProperties(_ref, _excluded);

  return /*#__PURE__*/_react.default.createElement(_reactBootstrap.Card, _extends({
    border: "primary",
    style: {
      width: width
    }
  }, props), header && /*#__PURE__*/_react.default.createElement(Header, null, header), /*#__PURE__*/_react.default.createElement(Body, null, title && /*#__PURE__*/_react.default.createElement(Title, null, title), body && /*#__PURE__*/_react.default.createElement(Text, null, body)));
};

exports.Card = Card;
Card.defaultProps = {
  width: '18rem',
  bg: undefined,
  border: undefined,
  text: undefined,
  header: '',
  title: '',
  body: ''
};
Card.propTypes = {
  width: _propTypes.default.oneOfType([_propTypes.default.number, _propTypes.default.string]),
  bg: _propTypes.default.oneOf(Object.values(cardBgs)),
  border: _propTypes.default.oneOf(Object.values(cardBgs)),
  text: _propTypes.default.oneOf(Object.values(cardTexts)),
  header: _propTypes.default.any,
  title: _propTypes.default.any,
  body: _propTypes.default.any
};
var _default = Card;
exports.default = _default;