"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InputSearch = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactBootstrap = require("react-bootstrap");

var _excluded = ["placeholder", "value", "defaultValue", "onChange", "onSearch"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var inputSearchSize = {
  SM: 'sm',
  LG: 'lg'
};

var InputSearch = function InputSearch(_ref) {
  var placeholder = _ref.placeholder,
      value = _ref.value,
      defaultValue = _ref.defaultValue,
      onChange = _ref.onChange,
      onSearch = _ref.onSearch,
      props = _objectWithoutProperties(_ref, _excluded);

  var _React$useState = _react.default.useState(value || defaultValue),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      val = _React$useState2[0],
      setVal = _React$useState2[1];

  var handleOnSearch = function handleOnSearch() {
    onSearch(val);
  };

  var handleOnChange = function handleOnChange(event) {
    setVal(event.target.value);
    onChange(event);
  };

  var handleOnKeyDown = function handleOnKeyDown(event) {
    if (event.keyCode === 13) {
      event.preventDefault();
      handleOnSearch();
    }
  };

  return /*#__PURE__*/_react.default.createElement(_reactBootstrap.InputGroup, _extends({
    className: "mb-3"
  }, props), /*#__PURE__*/_react.default.createElement(_reactBootstrap.Form.Control, {
    placeholder: placeholder,
    type: "search",
    value: val,
    onChange: handleOnChange,
    onKeyDown: handleOnKeyDown
  }), /*#__PURE__*/_react.default.createElement(_reactBootstrap.Button, {
    style: {
      borderColor: '#ced4da'
    },
    variant: "outline-secondary",
    className: "input-search-button",
    onClick: handleOnSearch
  }, /*#__PURE__*/_react.default.createElement("i", {
    className: "bi bi-search"
  })));
};

exports.InputSearch = InputSearch;
InputSearch.defaultProps = {
  placeholder: 'Search...',
  size: undefined,
  value: '',
  defaultValue: '',
  onChange: function onChange() {},
  onSearch: function onSearch() {}
};
InputSearch.propTypes = {
  placeholder: _propTypes.default.string,
  size: _propTypes.default.oneOf(Object.values(inputSearchSize)),
  value: _propTypes.default.string,
  defaultValue: _propTypes.default.string,
  onChange: _propTypes.default.func,
  onSearch: _propTypes.default.func
};
var _default = InputSearch;
exports.default = _default;