"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Loading = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactBootstrap = require("react-bootstrap");

require("./index.css");

var _excluded = ["className", "open", "background"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Loading = function Loading(_ref) {
  var className = _ref.className,
      open = _ref.open,
      background = _ref.background,
      props = _objectWithoutProperties(_ref, _excluded);

  return open && /*#__PURE__*/_react.default.createElement("div", {
    style: {
      background: background
    },
    className: "loading-root ".concat(className)
  }, /*#__PURE__*/_react.default.createElement(_reactBootstrap.Spinner, _extends({
    role: "status"
  }, props), /*#__PURE__*/_react.default.createElement("span", {
    className: "visually-hidden"
  }, "Loading...")));
};

exports.Loading = Loading;
Loading.defaultProps = {
  className: '',
  open: false,
  animation: 'border',
  size: undefined,
  variant: 'light',
  background: '#00000091'
};
Loading.propTypes = {
  className: _propTypes.default.string,
  open: _propTypes.default.bool,
  animation: _propTypes.default.oneOf(['border', 'grow']),
  size: _propTypes.default.oneOf(['sm']),
  variant: _propTypes.default.oneOf(['primary', 'secondary', 'success', 'danger', 'warning', 'info', 'light', 'dark']),
  background: _propTypes.default.string
};
var _default = Loading;
exports.default = _default;