"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Select = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactBootstrap = require("react-bootstrap");

var _excluded = ["data", "onChange"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var Select = function Select(_ref) {
  var data = _ref.data,
      onChange = _ref.onChange,
      props = _objectWithoutProperties(_ref, _excluded);

  var handleOnChange = function handleOnChange(e) {
    onChange(e.target.value, e);
  };

  return /*#__PURE__*/_react.default.createElement(_reactBootstrap.FormSelect, _extends({
    onChange: handleOnChange
  }, props), data.map(function (item) {
    return /*#__PURE__*/_react.default.createElement("option", {
      key: item.id,
      value: item.id,
      disabled: item.disabled
    }, item.name);
  }));
};

exports.Select = Select;
Select.defaultProps = {
  data: [],
  disabled: false,
  value: '',
  onChange: function onChange() {}
};
Select.propTypes = {
  data: _propTypes.default.arrayOf(Object),
  disabled: _propTypes.default.bool,
  value: _propTypes.default.string,
  onChange: _propTypes.default.func
};
exports.Select = Select = /*#__PURE__*/_react.default.memo(Select);
var _default = Select;
exports.default = _default;