"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.tablesVariants = exports.Tables = exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _reactBootstrap = require("react-bootstrap");

require("./index.css");

var _lodash = require("lodash");

var _Paginations = _interopRequireDefault(require("../Paginations"));

var _Select = _interopRequireDefault(require("../Select"));

var _excluded = ["data", "columns", "rowKey", "value", "onChange", "ellipsis", "className", "maxHeight", "theadClassName", "pagination", "PaginationsProps", "renderDataNotFound"],
    _excluded2 = ["pageSizeOptions", "renderTotalText"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var tablesVariants = {
  PRIMARY: 'primary',
  SECONDARY: 'secondary',
  SUCCESS: 'success',
  DANGER: 'danger',
  WARNING: 'warning',
  INFO: 'info',
  DARK: 'dark',
  LIGHT: 'light',
  LINK: 'link'
};
exports.tablesVariants = tablesVariants;
var PAGE_SIZE_OPTIONS = [{
  id: 5,
  name: 5
}, {
  id: 10,
  name: 10
}, {
  id: 20,
  name: 20
}, {
  id: 50,
  name: 50
}, {
  id: 100,
  name: 100
}];
var DEFAULT_PAGE_SIZE = 10;
var DEFAULT_PAGINATIONS_PROPS = {
  config: 5,
  size: 'sm',
  pageSize: DEFAULT_PAGE_SIZE,
  pageSizeOptions: PAGE_SIZE_OPTIONS,
  renderTotalText: function renderTotalText(length) {
    return "Total: ".concat(length);
  }
};
var PAGINATIONS_SIZE = {
  sm: 'form-select-sm',
  lg: 'form-select-lg'
};

var Tables = function Tables(_ref) {
  var _ref2;

  var initData = _ref.data,
      columns = _ref.columns,
      rowKey = _ref.rowKey,
      value = _ref.value,
      onChange = _ref.onChange,
      ellipsis = _ref.ellipsis,
      className = _ref.className,
      maxHeight = _ref.maxHeight,
      theadClassName = _ref.theadClassName,
      pagination = _ref.pagination,
      initPaginationsProps = _ref.PaginationsProps,
      renderDataNotFound = _ref.renderDataNotFound,
      props = _objectWithoutProperties(_ref, _excluded);

  var _Object$assign = Object.assign(DEFAULT_PAGINATIONS_PROPS, initPaginationsProps),
      pageSizeOptions = _Object$assign.pageSizeOptions,
      renderTotalText = _Object$assign.renderTotalText,
      PaginationsProps = _objectWithoutProperties(_Object$assign, _excluded2);

  var _useState = (0, _react.useState)(PaginationsProps.pageSize),
      _useState2 = _slicedToArray(_useState, 2),
      pageSize = _useState2[0],
      setPageSize = _useState2[1];

  var _useState3 = (0, _react.useState)(0),
      _useState4 = _slicedToArray(_useState3, 2),
      activeIndex = _useState4[0],
      setActiveIndex = _useState4[1];

  var _useState5 = (0, _react.useState)(pagination ? initData === null || initData === void 0 ? void 0 : initData.slice(0, pageSize) : initData),
      _useState6 = _slicedToArray(_useState5, 2),
      data = _useState6[0],
      setData = _useState6[1];

  var isEmpty = (initData === null || initData === void 0 ? void 0 : initData.length) <= 0;

  var freshData = function freshData() {
    var totalPage = Math.ceil((initData === null || initData === void 0 ? void 0 : initData.length) / pageSize);
    handleChangePage(Math.min(activeIndex, totalPage - 1), pageSize);
  };

  (0, _react.useEffect)(function () {
    if (pagination) {
      freshData();
    }
  }, [initData, pagination]);

  var handleOnChange = function handleOnChange(val, item) {
    return function (e) {
      onChange(val, e, item);
    };
  };

  var handleChangePage = function handleChangePage(value) {
    var vPageSize = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : pageSize;
    setActiveIndex(value);
    var start = value * vPageSize;
    var newData = initData === null || initData === void 0 ? void 0 : initData.slice(start, start + vPageSize);
    setData(newData);
  };

  var handlePageSize = function handlePageSize(value) {
    var vPageSize = Number(value);
    setActiveIndex(0);
    setPageSize(vPageSize);
    handleChangePage(0, vPageSize);
  };

  return /*#__PURE__*/_react.default.createElement("div", {
    className: "table-container"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: maxHeight ? 'table-scroll' : '',
    style: {
      maxHeight: maxHeight
    }
  }, /*#__PURE__*/_react.default.createElement(_reactBootstrap.Table, _extends({
    className: "".concat(className, " ").concat(ellipsis ? 'table-ellipsis' : '')
  }, props), /*#__PURE__*/_react.default.createElement("thead", {
    className: theadClassName
  }, /*#__PURE__*/_react.default.createElement("tr", null, pagination && /*#__PURE__*/_react.default.createElement("th", {
    className: "center"
  }, "#"), columns === null || columns === void 0 ? void 0 : columns.map(function (col) {
    return /*#__PURE__*/_react.default.createElement("th", {
      key: col.dataIndex
    }, col.title);
  }))), /*#__PURE__*/_react.default.createElement("tbody", null, isEmpty && /*#__PURE__*/_react.default.createElement("tr", null, /*#__PURE__*/_react.default.createElement("td", {
    colSpan: (columns === null || columns === void 0 ? void 0 : columns.length) + 1
  }, renderDataNotFound(PAGINATIONS_SIZE[props.size]))), (_ref2 = pagination ? data : initData) === null || _ref2 === void 0 ? void 0 : _ref2.map(function (item, rowIndex) {
    var id = item[rowKey];
    var trClassName = id === value ? 'tables-item-selected' : '';
    return /*#__PURE__*/_react.default.createElement("tr", {
      key: id,
      className: trClassName,
      onClick: handleOnChange(id, item)
    }, pagination && /*#__PURE__*/_react.default.createElement("td", {
      className: "center ".concat(trClassName)
    }, activeIndex * pageSize + rowIndex + 1), columns === null || columns === void 0 ? void 0 : columns.map(function (col) {
      var render = col.render,
          dataIndex = col.dataIndex;
      var label = item[dataIndex];

      if (typeof render === 'function') {
        label = render(id, _objectSpread(_objectSpread({}, item), {}, {
          rowIndex: rowIndex
        }));
      }

      return /*#__PURE__*/_react.default.createElement("td", {
        title: (0, _lodash.isString)(label) ? label : undefined,
        key: "".concat(id).concat(dataIndex),
        className: trClassName
      }, label);
    }));
  })))), pagination && !isEmpty && /*#__PURE__*/_react.default.createElement("div", {
    className: "table-paginations"
  }, /*#__PURE__*/_react.default.createElement("span", {
    className: PAGINATIONS_SIZE[PaginationsProps.size]
  }, renderTotalText(initData === null || initData === void 0 ? void 0 : initData.length)), /*#__PURE__*/_react.default.createElement("span", null, /*#__PURE__*/_react.default.createElement(_Select.default, {
    data: pageSizeOptions,
    onChange: handlePageSize,
    value: "".concat(pageSize),
    size: PaginationsProps.size
  })), /*#__PURE__*/_react.default.createElement(_Paginations.default, _extends({
    count: initData === null || initData === void 0 ? void 0 : initData.length,
    activeIndex: activeIndex,
    onChange: handleChangePage
  }, PaginationsProps, {
    pageSize: pageSize
  }))));
};

exports.Tables = Tables;
Tables.defaultProps = {
  data: [],
  columns: [],
  rowKey: 'id',
  striped: true,
  bordered: true,
  hover: true,
  responsive: true,
  borderless: false,
  size: undefined,
  variant: undefined,
  value: '',
  onChange: function onChange(value, event, rowData) {},
  ellipsis: true,
  className: '',
  maxHeight: undefined,
  theadClassName: '',
  pagination: false,
  PaginationsProps: DEFAULT_PAGINATIONS_PROPS,
  renderDataNotFound: function renderDataNotFound(className) {
    return /*#__PURE__*/_react.default.createElement("div", {
      className: "data-not-found ".concat(className)
    }, "Data Not Found");
  }
};
Tables.propTypes = {
  data: _propTypes.default.arrayOf(Object),
  columns: _propTypes.default.arrayOf(Object),
  rowKey: _propTypes.default.string,
  striped: _propTypes.default.bool,
  bordered: _propTypes.default.bool,
  hover: _propTypes.default.bool,
  responsive: _propTypes.default.bool,
  borderless: _propTypes.default.bool,
  size: _propTypes.default.oneOf(['sm', 'lg']),
  variant: _propTypes.default.oneOf(Object.values(tablesVariants)),
  value: _propTypes.default.string,
  onChange: _propTypes.default.func,
  ellipsis: _propTypes.default.bool,
  className: _propTypes.default.string,
  maxHeight: _propTypes.default.string,
  theadClassName: _propTypes.default.string,
  pagination: _propTypes.default.bool,
  PaginationsProps: _propTypes.default.instanceOf(Object),
  renderDataNotFound: _propTypes.default.func
};
var _default = Tables;
exports.default = _default;