"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.typographySize = exports.typographyTransform = exports.typographyAlign = exports.typographyBg = exports.typographyColor = exports.Typography = exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _excluded = ["className", "bg", "color", "align", "transform", "size", "ellipsis"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var typographyColor = {
  PRIMARY: 'primary',
  SECONDARY: 'secondary',
  SUCCESS: 'success',
  DANGER: 'danger',
  WARNING: 'warning',
  INFO: 'info',
  LIGHT: 'light',
  DARK: 'dark',
  BODY: 'body',
  MUTED: 'muted',
  WHITE: 'white',
  BLACK_50: 'black-50',
  WHITE_50: 'white-50'
};
exports.typographyColor = typographyColor;
var typographyBg = {
  PRIMARY: 'primary',
  SECONDARY: 'secondary',
  SUCCESS: 'success',
  DANGER: 'danger',
  WARNING: 'warning',
  INFO: 'info',
  LIGHT: 'light',
  DARK: 'dark',
  BODY: 'body',
  WHITE: 'white'
};
exports.typographyBg = typographyBg;
var typographyAlign = {
  START: 'start',
  CENTER: 'center',
  END: 'end'
};
exports.typographyAlign = typographyAlign;
var typographyTransform = {
  LOWERCASE: 'lowercase',
  UPPERCASE: 'uppercase',
  CAPITALIZE: 'capitalize'
};
exports.typographyTransform = typographyTransform;
var typographySize = {
  FS_1: '1',
  FS_2: '2',
  FS_3: '3',
  FS_4: '4',
  FS_5: '5',
  FS_6: '6'
};
exports.typographySize = typographySize;

var Typography = function Typography(_ref) {
  var className = _ref.className,
      bg = _ref.bg,
      color = _ref.color,
      align = _ref.align,
      transform = _ref.transform,
      size = _ref.size,
      ellipsis = _ref.ellipsis,
      props = _objectWithoutProperties(_ref, _excluded);

  var bgClassName = bg ? "bg-".concat(bg) : '';
  var colorClassName = color ? "text-".concat(color) : '';
  var alignClassName = align ? "text-".concat(align) : '';
  var transformClassName = transform ? "text-".concat(transform) : '';
  var sizeClassName = size ? "fs-".concat(size) : '';
  var ellipsisClassName = ellipsis ? 'text-truncate' : '';
  return /*#__PURE__*/_react.default.createElement("p", _extends({
    className: "\n        ".concat(bgClassName, " \n        ").concat(colorClassName, " \n        ").concat(alignClassName, " \n        ").concat(transformClassName, " \n        ").concat(sizeClassName, " \n        ").concat(ellipsisClassName, "\n        ").concat(className, "\n      ")
  }, props));
};

exports.Typography = Typography;
Typography.defaultProps = {
  className: '',
  color: undefined,
  bg: undefined,
  align: undefined,
  transform: undefined,
  size: undefined,
  ellipsis: false
};
Typography.propTypes = {
  className: _propTypes.default.string,
  color: _propTypes.default.oneOf(Object.values(typographyColor)),
  bg: _propTypes.default.oneOf(Object.values(typographyBg)),
  align: _propTypes.default.oneOf(Object.values(typographyAlign)),
  transform: _propTypes.default.oneOf(Object.values(typographyTransform)),
  size: _propTypes.default.oneOf(Object.values(typographySize)),
  ellipsis: _propTypes.default.bool
};
var _default = Typography;
exports.default = _default;